import { ModuleDescription, ModuleData, AdventureImage, CaptionImage } from "./IAdventure";
import { ModuleScene } from "./ModuleScene";
import { PdfData } from "../parse";
import { PageLayoutEmitFunction, PageLayout } from "./PageLayouts";
import * as EC from './extinctioncurse';
import { sentenceCase } from "./core";

const adventureModule : ModuleDescription = {
    prefix: "extinction-curse1",
    fullName: "Extinction Curse - The Show Must Go On",
    detect: (pdf: PdfData) => {
        return pdf.textDetails.some(t => t.text.trim() == 'EXTINCTION CURSE: THE SHOW MUST GO ON' && t.fontId == 'Gin-Regular:12');
    },
    extractDetails: EC.extractDetails,
    detectPageLayout: EC.detectPageLayout,
    pages: [
        // chapter 1
        new EC.ChapterHeadingPageLayout(6),
        new EC.RightSingleColumnWithSidebar(7),
        new EC.LeftTwoColumnWithMap(8, 340),
        new EC.RightTwoColumn(9),
        new EC.LeftTwoColumn(10),
        new EC.RightTwoColumn(11),
        new EC.LeftTwoColumnWithMap(12, 340),
        new EC.RightTwoColumn(13),
        new EC.LeftTwoColumn(14),
        new EC.RightTwoColumn(15),
        new EC.LeftTwoColumn(16),
        new EC.RightTwoColumn(17),

        // chapter 2
        new EC.ChapterHeadingPageLayout(18),
        new EC.RightSingleColumnWithSidebar(19),
        new EC.LeftTwoColumnWithMap(20, 340),
        new EC.RightTwoColumn(21),
        new EC.LeftTwoColumn(22),
        new EC.RightTwoColumn(23),
        new EC.LeftTwoColumn(24),
        new EC.RightTwoColumn(25),
        new EC.LeftTwoColumnWithMap(26, 340),
        new EC.RightTwoColumn(27),
        new EC.LeftTwoColumn(28),
        new EC.RightTwoColumn(29),
        new EC.LeftTwoColumn(30),
        new EC.RightTwoColumn(31),
        new EC.LeftTwoColumn(32),
        new EC.RightTwoColumn(33),

        // chapter 3
        new EC.ChapterHeadingPageLayout(34),
        new EC.RightSingleColumnWithSidebar(35),
        new EC.LeftTwoColumnWithMap(36, 340),
        new EC.RightTwoColumn(37),
        new EC.LeftTwoColumn(38),
        new EC.RightTwoColumn(39),
        new EC.LeftTwoColumn(40),
        new EC.RightTwoColumn(41),
        new EC.LeftTwoColumn(42),
        new EC.RightTwoColumn(43),
        new EC.LeftTwoColumn(44),
        new EC.RightTwoColumn(45),
        new EC.LeftTwoColumn(46),
        new EC.RightTwoColumn(47),

        // chapter 4
        new EC.ChapterHeadingPageLayout(48),
        new EC.RightSingleColumnWithSidebar(49),
        new EC.LeftTwoColumn(50),
        new EC.RightTwoColumn(51),
        new EC.LeftTwoColumn(52),
        new EC.RightTwoColumn(53),
        new EC.LeftTwoColumn(54),
        new EC.RightTwoColumn(55),
        new EC.LeftTwoColumn(56),
        new EC.RightTwoColumn(57),
        new EC.LeftTwoColumn(58),
        new EC.RightTwoColumn(59),

        // appendix 1
        new EC.RightChapterHeadingPageLayout(61),
        new EC.LeftTwoColumn(62),
        new EC.RightTwoColumn(63),
        new EC.LeftTwoColumn(64),
        new EC.RightTwoColumn(65),
        new EC.LeftTwoColumn(66),
        new EC.RightTwoColumnWithRightCutout(67, 90),
        new EC.LeftTwoColumn(68),
        new EC.RightTwoColumnWithRightCutout(69, 270),
        // 70 is circus sheet
        new EC.RightTwoColumn(71),

        // toolbox
        new EC.RightChapterHeadingPageLayout(73),
        new EC.LeftTwoColumn(74),
        new EC.RightTwoColumn(75),
        new EC.LeftTwoColumn(76),
        new EC.RightTwoColumn(77),
        new EC.LeftTwoColumn(78),
        new EC.RightTwoColumnWithBottomCutout(79, 235),
        new EC.LeftTwoColumn(80),
        new EC.RightTwoColumn(81),
        new EC.LeftSingleColumnWithSidebar(82),
        new EC.RightSingleColumnWithSidebar(83),
        new EC.LeftSingleColumnWithSidebar(84),        
        new EC.RightSingleColumnWithSidebar(85),        
        new EC.LeftSingleColumnWithSidebar(86),
        new EC.RightSingleColumnWithSidebar(87),
        new EC.LeftSingleColumnWithSidebar(88),
        new EC.RightSingleColumnWithSidebar(89),
        new EC.ChapterHeadingPageLayout(90),
        new EC.RightTwoColumn(91),
        new EC.ChapterHeadingPageLayout(92),
        new EC.RightTwoColumn(93),
    ],
    scenes: [
        new ModuleScene({
            name: 'map1',
            nameInfo: { x: 16, y: 758.8362 },
            nameFn: name => sentenceCase(name),
            page: 8, width: 1261, height: 880,
            imageLeft: 5, imageRight: 1239, imageCols: 20,
            imageTop: 4, imageBottom: 870, imageRows: 14,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map2',
            nameInfo: { x: 16, y: 758.8362 },
            nameFn: name => sentenceCase(name),
            page: 12, width: 1261, height: 880,
            imageLeft: 22, imageRight: 1232, imageCols: 30,
            imageTop: 33, imageBottom: 845, imageRows: 20,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map3a',
            nameInfo: { x: 129, y: 758.8362 },
            nameFn: name => sentenceCase(name),
            page: 20, width: 1261, height: 880,
            cropLeft: 0, cropRight: 619, cropTop: 0, cropBottom: 436,
            imageLeft: 7, imageRight: 612, imageCols: 36,
            imageTop: 3, imageBottom: 427, imageRows: 25,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map3b',
            nameInfo: { x: 343.6077, y: 758.8362 },
            nameFn: name => sentenceCase(name),
            page: 20, width: 1261, height: 880,
            cropLeft: 623, cropRight: 1261, cropTop: 0, cropBottom: 436,
            imageLeft: 647, imageRight: 1247, imageCols: 21,
            imageTop: 16, imageBottom: 418, imageRows: 14,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map3c',
            nameInfo: { x: 16, y: 553 },
            nameFn: name => sentenceCase(name),
            page: 20, width: 1261, height: 880,
            cropLeft: 0, cropRight: 619, cropTop: 441, cropBottom: 880,
            imageLeft: 6, imageRight: 597, imageCols: 21,
            imageTop: 450, imageBottom: 872, imageRows: 15,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map3d',
            nameInfo: { x: 313.5, y: 553 },
            nameFn: name => sentenceCase(name),
            page: 20, width: 1261, height: 880,
            cropLeft: 623, cropRight: 1261, cropTop: 441, cropBottom: 880,
            imageLeft: 640, imageRight: 1240, imageCols: 21,
            imageTop: 453, imageBottom: 855, imageRows: 14,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map4',
            nameInfo: { x: 16, y: 758.8362 },
            nameFn: name => sentenceCase(name),
            page: 26, width: 1261, height: 880,
            imageLeft: 36, imageRight: 1256, imageCols: 31,
            imageTop: 19, imageBottom: 847, imageRows: 21,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map5a',
            nameInfo: { x: 16, y: 758.8362 },
            nameFn: name => sentenceCase(name) + ' - Ground Level',
            page: 32, width: 1261, height: 880,
            cropLeft: 0, cropRight: 620, cropTop: 0, cropBottom: 880,
            imageLeft: 12, imageRight: 609, imageCols: 16,
            imageTop: 9, imageBottom: 868, imageRows: 23,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map5b',
            nameInfo: { x: 16, y: 758.8362 },
            nameFn: name => sentenceCase(name) + ' - Loft',
            page: 32, width: 1261, height: 880,
            cropLeft: 624, cropRight: 1261, cropTop: 0, cropBottom: 880,
            imageLeft: 652, imageRight: 1249, imageCols: 16,
            imageTop: 10, imageBottom: 868, imageRows: 23,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map6',
            nameInfo: { x: 16, y: 758.8362 },
            nameFn: name => sentenceCase(name),
            page: 36, width: 1261, height: 880,
            imageLeft: 9, imageRight: 1244, imageCols: 54,
            imageTop: 16, imageBottom: 862, imageRows: 37,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map7',
            nameInfo: { x: 337.084, y: 389.3881 },
            nameFn: name => sentenceCase(name),
            page: 51, width: 786, height: 737,
            imageLeft: 77, imageRight: 736, imageCols: 37,
            imageTop: 60, imageBottom: 683, imageRows: 35,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map8',
            nameInfo: { x: 313.216, y: 699 },
            nameFn: name => sentenceCase(name),
            page: 55, width: 586, height: 589,
            imageLeft: 63, imageRight: 526, imageCols: 26,
            imageTop: 72, imageBottom: 516, imageRows: 25,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map9',
            nameInfo: { x: 276.5545, y: 657.2635 },
            nameFn: name => sentenceCase(name),
            page: 58, width: 491, height: 491,
            imageLeft: 68, imageRight: 423, imageCols: 20,
            imageTop: 69, imageBottom: 423, imageRows: 20,
            globalLight: true,
        }),
    ],
    journals: [
        new AdventureImage({ name: 'journal1', page: 2, width: 589, height: 809, index: 0 }),
        new AdventureImage({ name: 'journal2', page: 2, width: 589, height: 809, index: 1 }),
        new AdventureImage({ name: 'journal3', page: 2, width: 589, height: 809, index: 2 }),
        new AdventureImage({ name: 'journal4', page: 2, width: 589, height: 809, index: 3 }),
        new AdventureImage({ name: 'journal5', page: 2, width: 589, height: 809, index: 4 }),
        new AdventureImage({ name: 'journal6', page: 2, width: 589, height: 809, index: 5 }),
        new AdventureImage({ name: 'journal7', page: 4, width: 1261, height: 1636 }),
        new AdventureImage({ name: 'journal8', page: 6, width: 1259, height: 805 }),
        new CaptionImage({ name: 'journal9', page: 14, width: 495, height: 569 }),
        new AdventureImage({ name: 'journal10', page: 18, width: 1259, height: 805 }),
        new AdventureImage({ name: 'journal11', page: 34, width: 1259, height: 805 }),
        new AdventureImage({ name: 'journal12', page: 48, width: 1259, height: 805 }),
        new AdventureImage({ name: 'journal13', page: 50, width: 300, height: 300 }),
        new AdventureImage({ name: 'journal14', page: 60, width: 1261, height: 1636 }),
        new AdventureImage({ name: 'journal15', page: 64, width: 823, height: 1151 }),
        new AdventureImage({ name: 'journal16', page: 66, width: 763, height: 763 }),
        new AdventureImage({ name: 'journal17', page: 72, width: 1261, height: 1636 }),
        new AdventureImage({ name: 'journal18', page: 76, width: 794, height: 1025 }),
        new AdventureImage({ name: 'journal19', page: 77, width: 819, height: 1440 }),
        new AdventureImage({ name: 'journal20', page: 79, width: 467, height: 467 }),
        new AdventureImage({ name: 'journal21', page: 79, width: 576, height: 576 }),
        new AdventureImage({ name: 'journal22', page: 81, width: 731, height: 1150 }),

        new CaptionImage({ name: 'npc1', page: 9, width: 495, height: 535 }),
        new CaptionImage({ name: 'npc2', page: 17, width: 926, height: 1159 }),
        new CaptionImage({ name: 'npc3', page: 21, width: 478, height: 587 }),
        new CaptionImage({ name: 'npc4', page: 25, width: 752, height: 1052 }),
        new CaptionImage({ name: 'npc5', page: 28, width: 513, height: 604 }),
        new CaptionImage({ name: 'npc6', page: 31, width: 755, height: 1125 }),
        new CaptionImage({ name: 'npc7', page: 37, width: 782, height: 1031 }),
        new CaptionImage({ name: 'npc8', page: 40, width: 871, height: 785 }),
        new CaptionImage({ name: 'npc9', page: 42, width: 858, height: 1200 }),
        new CaptionImage({ name: 'npc10', page: 46, width: 1024, height: 1011 }),
        new CaptionImage({ name: 'npc11', page: 47, width: 455, height: 1112 }),
        new CaptionImage({ name: 'npc12', page: 52, width: 993, height: 828 }),
        new CaptionImage({ name: 'npc13', page: 53, width: 1213, height: 826 }),
        new CaptionImage({ name: 'npc14', page: 56, width: 518, height: 528 }),
        new CaptionImage({ name: 'npc15', page: 57, width: 794, height: 1200 }),
        new CaptionImage({ name: 'npc16', page: 82, width: 911, height: 869 }),
        new CaptionImage({ name: 'npc17', page: 83, width: 822, height: 1230 }),
        new CaptionImage({ name: 'npc18', page: 84, width: 650, height: 1147 }),
        new CaptionImage({ name: 'npc19', page: 85, width: 921, height: 1103 }),
        new CaptionImage({ name: 'npc20', page: 86, width: 653, height: 1235 }),
        new CaptionImage({ name: 'npc21', page: 87, width: 641, height: 761 }),
        new CaptionImage({ name: 'npc22', page: 88, width: 908, height: 1068 }),
        new CaptionImage({ name: 'npc23', page: 89, width: 840, height: 1068 }),
        new CaptionImage({ name: 'npc24', page: 91, width: 878, height: 1069 }),
        new CaptionImage({ name: 'npc25', page: 93, width: 867, height: 1160 }),
    ],
    finalize: (moduleData: ModuleData) => {
    }
};

export default adventureModule;